#!/usr/bin/env python2.5

# 
# Copyright (c) 2007-2008 INdT.
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU Lesser General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
#  This program is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#  GNU Lesser General Public License for more details.
#
#  You should have received a copy of the GNU Lesser General Public License
#  along with this program.  If not, see <http://www.gnu.org/licenses/>.
#

# ============================================================================
# Name        : hello_world.py
# Author      : group1
# Version     : 0.1
# Description : Python Hildon Hello World
# ============================================================================


import gtk 
import hildon
import string
import pygame
import time

class HelloWorldApp(hildon.Program):
    def __init__(self):
        hildon.Program.__init__(self)

        self.window = hildon.Window()
        self.window.fullscreen()
        self.window.connect("delete_event", self.quit)  
        self.add_window(self.window)
        self.mainpage = True

        self.state = True
        self.chord = ""
        self.chordletter = ""
        self.chordsound = ""
        self.soundplaying = False
        pygame.init()
        self.chords = ["A", "B", "C", "D", "E", "F", "G"]
        self.scales = ["Maj", "Min", "sMaj", "sMin"]
             
        #create a frame
        self.frame = gtk.Frame()
        self.window.add(self.frame)
        
        color = gtk.gdk.color_parse('#A3A3A3')
        self.window.modify_bg(gtk.STATE_NORMAL, color)
                
        #create a box that packs horizontally with spacing of 0
        self.hbox = gtk.HBox(homogeneous=False,spacing=0)
        self.frame.add(self.hbox)


        # Make the elements inside the frame
        #
        # Make the quit image
        self.vbox2 = gtk.VBox(False, 0)
        self.hbox.pack_start(self.vbox2, False, False, 0)      
        self.quitimage = gtk.Image()
        self.quitimage.set_from_file("images/x.png")
        
        
        self.quitbutton = gtk.Button()
        self.quitbutton.set_image(self.quitimage)
        self.quitimage.show()
        self.vbox2.pack_start(self.quitbutton, False, False, 0)
        self.quitbutton.connect("clicked", exit)
        self.quitbutton.show()            
        
        self.vbox2.show()        
        self.hbox.add(self.vbox2)
        
        
        # Make the image
        self.image = gtk.Image()
        self.image.set_from_file("images/background/logo.png")
        self.sound = pygame.mixer.Sound("sounds/intro.wav")
        self.sound.play()    
        #self.sound.fadeout(5)    
        self.hbox.add(self.image)  
   
        self.vbox = gtk.VBox(True, 5)
        self.hbox.pack_start(self.vbox, True, True, 0)
   
        ## Defining the buttons
        self.button1 = gtk.Button("button1")
        self.vbox.pack_start(self.button1, True, True, 0) 
        self.button1.show()
        
        self.button2 = gtk.Button("button2")
        self.vbox.pack_start(self.button2, True, True, 0)   
        self.button2.show()
        
        self.button3 = gtk.Button("button3")
        self.vbox.pack_start(self.button3, True, True, 0)
        self.button3.show()
        
        self.button4 = gtk.Button("button4")
        self.vbox.pack_start(self.button4, True, True, 0)
        self.button4.show()
        
        self.button5 = gtk.Button("button5")
        self.vbox.pack_start(self.button5, True, True, 0)
        self.button5.show()
        
        self.button6 = gtk.Button("button6")
        self.vbox.pack_start(self.button6, True, True, 0)
        self.button6.show()
        
        self.button7 = gtk.Button("button7")
        self.vbox.pack_start(self.button7, True, True, 0)
        self.button7.show()
        
        # Updates the content of boxes (A,B,C,D,E,F and G)
        self.updateboxes()
        
        # Connects click effects to the buttons
        self.button1.connect("clicked", self.callback, self.button1.get_label())
        self.button2.connect("clicked", self.callback, self.button2.get_label())   
        self.button3.connect("clicked", self.callback, self.button3.get_label())   
        self.button4.connect("clicked", self.callback, self.button4.get_label())   
        self.button5.connect("clicked", self.callback, self.button5.get_label())   
        self.button6.connect("clicked", self.callback, self.button6.get_label())                            
        self.button7.connect("clicked", self.callback, self.button7.get_label())   
        
        self.vbox.show()
        self.hbox.add(self.vbox) 
                
        self.hbox.show()    
        
        self.frame.show()
        
        
    
    def updateboxes(self):
        
        if self.state == True:
            self.button1.set_label(self.chords[0])          
            self.button2.set_label(self.chords[1])           
            self.button3.set_label(self.chords[2])  
            self.button4.set_label(self.chords[3])  
            self.button5.set_label(self.chords[4])  
            self.button6.set_label(self.chords[5])  
            self.button7.set_label(self.chords[6])
        
        else:
            self.button1.set_label(self.scales[0])          
            self.button2.set_label(self.scales[1])           
            self.button3.set_label(self.scales[2])  
            self.button4.set_label(self.scales[3])  
            self.button5.set_label("")  
            self.button6.set_label("")  
            self.button7.set_label("BACK")

                    
    def callback(self, widget, data):
        print "%s was pushed" % data       

        ## This is the 1st options, about which chord
        if self.state == True:
            if data == "A" or "B" or "C" or "D" or "E" or "F" or "G":
                self.state = False 
                self.chordletter = data
                self.updateboxes()

        ## 2nd option - the view to select the scale
        if self.state == False:
            self.chord = self.chordletter
            if self.soundplaying == True:
                self.sound.stop()
                self.soundplayign = False
            
            # Major
            if data == "A":
                self.chord = self.chord + self.scales[0]
                print "This is the self chord: " + self.chord
                self.sound = pygame.mixer.Sound("sounds/"+self.chord+".wav")
                self.sound.play()
                self.soundplaying = True
                print "Now playing..." 
                print self.chordsound
            # Minor
            elif data == "B":
                self.chord = self.chord + self.scales[1]
                print "this is the self chord: " + self.chord
                self.sound = pygame.mixer.Sound("sounds/"+self.chord+".wav")
                self.sound.play()
                self.soundplaying = True                
                print "Now playing..." 
            # SharpMajor
            elif data == "C":
                self.chord = self.chord + self.scales[2]
                self.sound = pygame.mixer.Sound("sounds/"+self.chord+".wav")
                self.sound.play()
                self.soundplaying = True
                print "This is the self chord: " + self.chord
                print "Now playing..." 
            # SharpMinor
            elif data == "D":
                self.chord = self.chord + self.scales[3]
                self.sound = pygame.mixer.Sound("sounds/"+self.chord+".wav")
                self.sound.play()
                self.soundplaying = True
                print "this is the self chord: " + self.chord
                print "Now playing..." 
           #
           # G of the 2nd level means BACK
           #   
            elif data == "G" and self.chordletter != "G":
                self.state = True
                self.updateboxes()
        
            self.image.set_from_file("images/" + self.chord + ".png")
            print data
            
            if data == "G":
                self.image.set_from_file("images/background/logo.png")
            
    def quit(self, *args):
        print "Goodbye world!"
        gtk.main_quit()
        
    def run(self):     
        self.window.show_all()
        gtk.main_iteration()
        gtk.main() 

if __name__ == "__main__":  
    app = HelloWorldApp() 
    app.run()         

